## m1n1 1.4.3

=== Makefile ===
RUSTARCH ?= aarch64-unknown-none-softfloat

ifeq ($(shell uname),Darwin)
USE_CLANG ?= 1
$(info INFO: Building on Darwin)
ifeq ($(shell uname -p),arm)
TOOLCHAIN ?= /opt/homebrew/opt/llvm/bin/
else
TOOLCHAIN ?= /usr/local/opt/llvm/bin/
endif
$(info INFO: Toolchain path: $(TOOLCHAIN))
endif

ifeq ($(shell uname -m),aarch64)
ARCH ?=
else
ARCH ?= aarch64-linux-gnu-
endif

ifeq ($(USE_CLANG),1)
CC := $(TOOLCHAIN)clang --target=$(ARCH)
AS := $(TOOLCHAIN)clang --target=$(ARCH)
LD := $(TOOLCHAIN)ld.lld
OBJCOPY := $(TOOLCHAIN)llvm-objcopy
CLANG_FORMAT := $(TOOLCHAIN)clang-format
EXTRA_CFLAGS ?=
else
CC := $(TOOLCHAIN)$(ARCH)gcc
AS := $(TOOLCHAIN)$(ARCH)gcc
LD := $(TOOLCHAIN)$(ARCH)ld
OBJCOPY := $(TOOLCHAIN)$(ARCH)objcopy
CLANG_FORMAT := clang-format
EXTRA_CFLAGS ?= -Wstack-usage=1024
endif

BASE_CFLAGS := -O2 -Wall -g -Wundef -Werror=strict-prototypes -fno-common -fno-PIE \
	-Werror=implicit-function-declaration -Werror=implicit-int \
	-Wsign-compare -Wunused-parameter -Wno-multichar \
	-ffreestanding -fpic -ffunction-sections -fdata-sections \
	-nostdinc -isystem $(shell $(CC) -print-file-name=include) -isystem sysinc \
	-fno-stack-protector -mstrict-align -march=armv8.2-a \
	$(EXTRA_CFLAGS)

CFLAGS := $(BASE_CFLAGS) -mgeneral-regs-only

CFG :=
ifeq ($(RELEASE),1)
CFG += RELEASE
endif

# Required for no_std + alloc for now
export RUSTC_BOOTSTRAP=1
RUST_LIB := librust.a
RUST_LIBS :=
ifeq ($(CHAINLOADING),1)
CFG += CHAINLOADING
RUST_LIBS += $(RUST_LIB)
endif

LDFLAGS := -EL -maarch64elf --no-undefined -X -Bsymbolic \
	-z notext --no-apply-dynamic-relocs --orphan-handling=warn \
	-z nocopyreloc --gc-sections -pie

MINILZLIB_OBJECTS := $(patsubst %,minilzlib/%, \
	dictbuf.o inputbuf.o lzma2dec.o lzmadec.o rangedec.o xzstream.o)

TINF_OBJECTS := $(patsubst %,tinf/%, \
	adler32.o crc32.o tinfgzip.o tinflate.o tinfzlib.o)

DLMALLOC_OBJECTS := dlmalloc/malloc.o

LIBFDT_OBJECTS := $(patsubst %,libfdt/%, \
	fdt_addresses.o fdt_empty_tree.o fdt_ro.o fdt_rw.o fdt_strerror.o fdt_sw.o \
	fdt_wip.o fdt.o)

DCP_OBJECTS := $(patsubst %,dcp/%, \
	dpav_ep.o \
	dptx_phy.o \
	dptx_port_ep.o \
	parser.o \
	system_ep.o)

OBJECTS := \
	adt.o \
	afk.o \
	aic.o \
	asc.o \
	bootlogo_128.o bootlogo_256.o \
	chainload.o \
	chainload_asm.o \
	chickens.o \
	chickens_avalanche.o \
	chickens_blizzard.o \
	chickens_firestorm.o \
	chickens_icestorm.o \
	clk.o \
	cpufreq.o \
	dapf.o \
	dart.o \
	dcp.o \
	dcp_iboot.o \
	devicetree.o \
	display.o \
	exception.o exception_asm.o \
	fb.o font.o font_retina.o \
	firmware.o \
	gxf.o gxf_asm.o \
	heapblock.o \
	hv.o hv_vm.o hv_exc.o hv_vuart.o hv_wdt.o hv_asm.o hv_aic.o hv_virtio.o \
	i2c.o \
	iodev.o \
	iova.o \
	isp.o \
	kboot.o \
	main.o \
	mcc.o \
	memory.o memory_asm.o \
	nvme.o \
	payload.o \
	pcie.o \
	pmgr.o \
	proxy.o \
	ringbuffer.o \
	rtkit.o \
	sart.o \
	sep.o \
	sio.o \
	smc.o \
	smp.o \
	start.o \
	startup.o \
	string.o \
	tunables.o tunables_static.o \
	tps6598x.o \
	uart.o \
	uartproxy.o \
	usb.o usb_dwc3.o \
	utils.o utils_asm.o \
	vsprintf.o \
	wdt.o \
	$(DCP_OBJECTS) \
	$(MINILZLIB_OBJECTS) $(TINF_OBJECTS) $(DLMALLOC_OBJECTS) $(LIBFDT_OBJECTS) $(RUST_LIBS)

FP_OBJECTS := \
	kboot_gpu.o \
	math/expf.o \
	math/exp2f_data.o \
	math/powf.o \
	math/powf_data.o

BUILD_OBJS := $(patsubst %,build/%,$(OBJECTS))
BUILD_FP_OBJS := $(patsubst %,build/%,$(FP_OBJECTS))
BUILD_ALL_OBJS := $(BUILD_OBJS) $(BUILD_FP_OBJS)
NAME := m1n1
TARGET := m1n1.macho
TARGET_RAW := m1n1.bin

DEPDIR := build/.deps

.PHONY: all clean format update_tag update_cfg invoke_cc
all: update_tag update_cfg build/$(TARGET) build/$(TARGET_RAW)
clean:
	rm -rf build/*
format:
	$(CLANG_FORMAT) -i src/*.c src/dcp/*.c src/math/*.c src/*.h src/dcp/*.h src/math/*.h sysinc/*.h
format-check:
	$(CLANG_FORMAT) --dry-run --Werror src/*.c src/*.h src/dcp/*.c src/dcp/*.h sysinc/*.h
rustfmt:
	cd rust && cargo fmt
rustfmt-check:
	cd rust && cargo fmt --check

build/$(RUST_LIB): rust/src/* rust/*
	@echo "  RS    $@"
	@mkdir -p $(DEPDIR)
	@mkdir -p "$(dir $@)"
	@cargo build --target $(RUSTARCH) --lib --release --manifest-path rust/Cargo.toml --target-dir build
	@cp "build/$(RUSTARCH)/release/${RUST_LIB}" "$@"

build/%.o: src/%.S
	@echo "  AS    $@"
	@mkdir -p $(DEPDIR)
	@mkdir -p "$(dir $@)"
	@$(AS) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<

$(BUILD_FP_OBJS): build/%.o: src/%.c
	@echo "  CC FP $@"
	@mkdir -p $(DEPDIR)
	@mkdir -p "$(dir $@)"
	@$(CC) -c $(BASE_CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<

build/%.o: src/%.c
	@echo "  CC    $@"
	@mkdir -p $(DEPDIR)
	@mkdir -p "$(dir $@)"
	@$(CC) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<

# special target for usage by m1n1.loadobjs
invoke_cc:
	@$(CC) -c $(CFLAGS) -Isrc -o $(OBJFILE) $(CFILE)

build/$(NAME).elf: $(BUILD_ALL_OBJS) m1n1.ld
	@echo "  LD    $@"
	@$(LD) -T m1n1.ld $(LDFLAGS) -o $@ $(BUILD_ALL_OBJS)

build/$(NAME)-raw.elf: $(BUILD_ALL_OBJS) m1n1-raw.ld
	@echo "  LDRAW $@"
	@$(LD) -T m1n1-raw.ld $(LDFLAGS) -o $@ $(BUILD_ALL_OBJS)

build/$(NAME).macho: build/$(NAME).elf
	@echo "  MACHO $@"
	@$(OBJCOPY) -O binary --strip-debug $< $@

build/$(NAME).bin: build/$(NAME)-raw.elf
	@echo "  RAW   $@"
	@$(OBJCOPY) -O binary --strip-debug $< $@

update_tag:
	@mkdir -p build
	@./version.sh > build/build_tag.tmp
	@cmp -s build/build_tag.h build/build_tag.tmp 2>/dev/null || \
	( mv -f build/build_tag.tmp build/build_tag.h && echo "  TAG   build/build_tag.h" )

update_cfg:
	@mkdir -p build
	@for i in $(CFG); do echo "#define $$i"; done > build/build_cfg.tmp
	@cmp -s build/build_cfg.h build/build_cfg.tmp 2>/dev/null || \
	( mv -f build/build_cfg.tmp build/build_cfg.h && echo "  CFG   build/build_cfg.h" )

build/build_tag.h: update_tag
build/build_cfg.h: update_cfg

build/%.bin: data/%.bin
	@echo "  IMG   $@"
	@mkdir -p "$(dir $@)"
	@cp $< $@

build/%.o: build/%.bin
	@echo "  BIN   $@"
	@mkdir -p "$(dir $@)"
	@$(OBJCOPY) -I binary -B aarch64 -O elf64-littleaarch64 $< $@

build/%.bin: font/%.bin
	@echo "  CP    $@"
	@mkdir -p "$(dir $@)"
	@cp $< $@

build/main.o: build/build_tag.h build/build_cfg.h src/main.c
build/usb_dwc3.o: build/build_tag.h src/usb_dwc3.c
build/chainload.o: build/build_cfg.h src/usb_dwc3.c

-include $(DEPDIR)/*

=== debian/changelog ===
m1n1 (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3
  * gbp.conf: Add upstream-vcs-tag

 -- Tobias Heider <me@tobhe.de>  Sun, 15 Oct 2023 16:38:24 +0200

m1n1 (1.3.3-1) unstable; urgency=medium

  * New upstream version 1.3.3
  * Update libfdt copyright to GPL-2.0-or-later or BSD-2-Clause

 -- Tobias Heider <me@tobhe.de>  Sat, 26 Aug 2023 19:13:00 +0200

m1n1 (1.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1042410)

 -- Tobias Heider <me@tobhe.de>  Sun, 11 Jun 2023 23:03:54 +0200

## m1n1 1.4.6

=== debian/changelog ===
m1n1 (1.4.6-1) unstable; urgency=medium

  * New upstream version 1.4.6

 -- Tobias Heider <me@tobhe.de>  Fri, 10 Nov 2023 15:55:18 +0100

## m1n1 1.4.8

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 LD := $(TOOLCHAIN)$(ARCH)ld
 OBJCOPY := $(TOOLCHAIN)$(ARCH)objcopy
 CLANG_FORMAT := clang-format
-EXTRA_CFLAGS ?= -Wstack-usage=1024
+EXTRA_CFLAGS ?= -Wstack-usage=2048
 endif
 
 BASE_CFLAGS := -O2 -Wall -g -Wundef -Werror=strict-prototypes -fno-common -fno-PIE \

## m1n1 1.4.11

=== Makefile ===
--- 
+++ 
@@ -31,6 +31,16 @@
 OBJCOPY := $(TOOLCHAIN)$(ARCH)objcopy
 CLANG_FORMAT := clang-format
 EXTRA_CFLAGS ?= -Wstack-usage=2048
+endif
+
+ifeq ($(V),)
+QUIET := @
+else
+ifeq ($(V),0)
+QUIET := @
+else
+QUIET :=
+endif
 endif
 
 BASE_CFLAGS := -O2 -Wall -g -Wundef -Werror=strict-prototypes -fno-common -fno-PIE \
@@ -91,8 +101,10 @@
 	chickens.o \
 	chickens_avalanche.o \
 	chickens_blizzard.o \
+	chickens_everest.o \
 	chickens_firestorm.o \
 	chickens_icestorm.o \
+	chickens_sawtooth.o \
 	clk.o \
 	cpufreq.o \
 	dapf.o \
@@ -171,79 +183,79 @@
 	cd rust && cargo fmt --check
 
 build/$(RUST_LIB): rust/src/* rust/*
-	@echo "  RS    $@"
-	@mkdir -p $(DEPDIR)
-	@mkdir -p "$(dir $@)"
-	@cargo build --target $(RUSTARCH) --lib --release --manifest-path rust/Cargo.toml --target-dir build
-	@cp "build/$(RUSTARCH)/release/${RUST_LIB}" "$@"
+	$(QUIET)echo "  RS    $@"
+	$(QUIET)mkdir -p $(DEPDIR)
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)cargo build --target $(RUSTARCH) --lib --release --manifest-path rust/Cargo.toml --target-dir build
+	$(QUIET)cp "build/$(RUSTARCH)/release/${RUST_LIB}" "$@"
 
 build/%.o: src/%.S
-	@echo "  AS    $@"
-	@mkdir -p $(DEPDIR)
-	@mkdir -p "$(dir $@)"
-	@$(AS) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
+	$(QUIET)echo "  AS    $@"
+	$(QUIET)mkdir -p $(DEPDIR)
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)$(AS) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
 
 $(BUILD_FP_OBJS): build/%.o: src/%.c
-	@echo "  CC FP $@"
-	@mkdir -p $(DEPDIR)
-	@mkdir -p "$(dir $@)"
-	@$(CC) -c $(BASE_CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
+	$(QUIET)echo "  CC FP $@"
+	$(QUIET)mkdir -p $(DEPDIR)
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)$(CC) -c $(BASE_CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
 
 build/%.o: src/%.c
-	@echo "  CC    $@"
-	@mkdir -p $(DEPDIR)
-	@mkdir -p "$(dir $@)"
-	@$(CC) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
+	$(QUIET)echo "  CC    $@"
+	$(QUIET)mkdir -p $(DEPDIR)
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)$(CC) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
 
 # special target for usage by m1n1.loadobjs
 invoke_cc:
-	@$(CC) -c $(CFLAGS) -Isrc -o $(OBJFILE) $(CFILE)
+	$(QUIET)$(CC) -c $(CFLAGS) -Isrc -o $(OBJFILE) $(CFILE)
 
 build/$(NAME).elf: $(BUILD_ALL_OBJS) m1n1.ld
-	@echo "  LD    $@"
-	@$(LD) -T m1n1.ld $(LDFLAGS) -o $@ $(BUILD_ALL_OBJS)
+	$(QUIET)echo "  LD    $@"
+	$(QUIET)$(LD) -T m1n1.ld $(LDFLAGS) -o $@ $(BUILD_ALL_OBJS)
 
 build/$(NAME)-raw.elf: $(BUILD_ALL_OBJS) m1n1-raw.ld
-	@echo "  LDRAW $@"
-	@$(LD) -T m1n1-raw.ld $(LDFLAGS) -o $@ $(BUILD_ALL_OBJS)
+	$(QUIET)echo "  LDRAW $@"
+	$(QUIET)$(LD) -T m1n1-raw.ld $(LDFLAGS) -o $@ $(BUILD_ALL_OBJS)
 
 build/$(NAME).macho: build/$(NAME).elf
-	@echo "  MACHO $@"
-	@$(OBJCOPY) -O binary --strip-debug $< $@
+	$(QUIET)echo "  MACHO $@"
+	$(QUIET)$(OBJCOPY) -O binary --strip-debug $< $@
 
 build/$(NAME).bin: build/$(NAME)-raw.elf
-	@echo "  RAW   $@"
-	@$(OBJCOPY) -O binary --strip-debug $< $@
+	$(QUIET)echo "  RAW   $@"
+	$(QUIET)$(OBJCOPY) -O binary --strip-debug $< $@
 
 update_tag:
-	@mkdir -p build
-	@./version.sh > build/build_tag.tmp
-	@cmp -s build/build_tag.h build/build_tag.tmp 2>/dev/null || \
+	$(QUIET)mkdir -p build
+	$(QUIET)./version.sh > build/build_tag.tmp
+	$(QUIET)cmp -s build/build_tag.h build/build_tag.tmp 2>/dev/null || \
 	( mv -f build/build_tag.tmp build/build_tag.h && echo "  TAG   build/build_tag.h" )
 
 update_cfg:
-	@mkdir -p build
-	@for i in $(CFG); do echo "#define $$i"; done > build/build_cfg.tmp
-	@cmp -s build/build_cfg.h build/build_cfg.tmp 2>/dev/null || \
+	$(QUIET)mkdir -p build
+	$(QUIET)for i in $(CFG); do echo "#define $$i"; done > build/build_cfg.tmp
+	$(QUIET)cmp -s build/build_cfg.h build/build_cfg.tmp 2>/dev/null || \
 	( mv -f build/build_cfg.tmp build/build_cfg.h && echo "  CFG   build/build_cfg.h" )
 
 build/build_tag.h: update_tag
 build/build_cfg.h: update_cfg
 
 build/%.bin: data/%.bin
-	@echo "  IMG   $@"
-	@mkdir -p "$(dir $@)"
-	@cp $< $@
+	$(QUIET)echo "  IMG   $@"
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)cp $< $@
 
 build/%.o: build/%.bin
-	@echo "  BIN   $@"
-	@mkdir -p "$(dir $@)"
-	@$(OBJCOPY) -I binary -B aarch64 -O elf64-littleaarch64 $< $@
+	$(QUIET)echo "  BIN   $@"
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)$(OBJCOPY) -I binary -B aarch64 -O elf64-littleaarch64 $< $@
 
 build/%.bin: font/%.bin
-	@echo "  CP    $@"
-	@mkdir -p "$(dir $@)"
-	@cp $< $@
+	$(QUIET)echo "  CP    $@"
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)cp $< $@
 
 build/main.o: build/build_tag.h build/build_cfg.h src/main.c
 build/usb_dwc3.o: build/build_tag.h src/usb_dwc3.c

=== debian/changelog ===
m1n1 (1.4.11-1) unstable; urgency=medium

  * New upstream version 1.4.11

 -- Tobias Heider <me@tobhe.de>  Sun, 17 Dec 2023 18:17:11 +0100

m1n1 (1.4.8-1) unstable; urgency=medium

  * New upstream version 1.4.8

 -- Tobias Heider <me@tobhe.de>  Fri, 08 Dec 2023 14:28:25 +0100

=== debian/control ===
Source: m1n1
Section: misc
Priority: optional
Maintainer: Tobias Heider <me@tobhe.de>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.2
Homepage: https://github.com/AsahiLinux/m1n1
Vcs-Browser: https://salsa.debian.org/bananas-team/m1n1
Vcs-Git: https://salsa.debian.org/bananas-team/m1n1.git
Rules-Requires-Root: no

Package: m1n1
Architecture: arm64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Bootloader for Apple Silicon
 This is the bootloader developed by the Asahi Linux project to bridge
 the Apple (XNU) boot ecosystem to the Linux boot ecosystem.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- RELEASE=1

## m1n1 1.4.13

=== debian/changelog ===
m1n1 (1.4.13-1) unstable; urgency=medium

  * New upstream version 1.4.13

 -- Tobias Heider <me@tobhe.de>  Fri, 17 May 2024 15:11:14 +0200

## m1n1 1.4.14

=== Makefile ===
--- 
+++ 
@@ -22,14 +22,14 @@
 AS := $(TOOLCHAIN)clang --target=$(ARCH)
 LD := $(TOOLCHAIN)ld.lld
 OBJCOPY := $(TOOLCHAIN)llvm-objcopy
-CLANG_FORMAT := $(TOOLCHAIN)clang-format
+CLANG_FORMAT ?= $(TOOLCHAIN)clang-format
 EXTRA_CFLAGS ?=
 else
 CC := $(TOOLCHAIN)$(ARCH)gcc
 AS := $(TOOLCHAIN)$(ARCH)gcc
 LD := $(TOOLCHAIN)$(ARCH)ld
 OBJCOPY := $(TOOLCHAIN)$(ARCH)objcopy
-CLANG_FORMAT := clang-format
+CLANG_FORMAT ?= clang-format
 EXTRA_CFLAGS ?= -Wstack-usage=2048
 endif
 
@@ -176,7 +176,7 @@
 format:
 	$(CLANG_FORMAT) -i src/*.c src/dcp/*.c src/math/*.c src/*.h src/dcp/*.h src/math/*.h sysinc/*.h
 format-check:
-	$(CLANG_FORMAT) --dry-run --Werror src/*.c src/*.h src/dcp/*.c src/dcp/*.h sysinc/*.h
+	$(CLANG_FORMAT) --dry-run --Werror src/*.c src/dcp/*.c src/math/*.c src/*.h src/dcp/*.h src/math/*.h sysinc/*.h
 rustfmt:
 	cd rust && cargo fmt
 rustfmt-check:

=== debian/changelog ===
m1n1 (1.4.14-1) unstable; urgency=medium

  * New upstream version 1.4.14

 -- Tobias Heider <me@tobhe.de>  Sat, 18 May 2024 13:27:57 +0200

## m1n1 1.4.16

=== debian/changelog ===
m1n1 (1.4.16-1) unstable; urgency=medium

  * New upstream version 1.4.16

 -- Tobias Heider <me@tobhe.de>  Sun, 29 Sep 2024 18:23:34 +0200

m1n1 (1.4.15-1) unstable; urgency=medium

  * New upstream version 1.4.15

 -- Tobias Heider <me@tobhe.de>  Fri, 20 Sep 2024 23:03:28 +0200

## m1n1 1.4.17

=== Makefile ===
--- 
+++ 
@@ -193,7 +193,7 @@
 	$(QUIET)echo "  AS    $@"
 	$(QUIET)mkdir -p $(DEPDIR)
 	$(QUIET)mkdir -p "$(dir $@)"
-	$(QUIET)$(AS) -c $(CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
+	$(QUIET)$(AS) -c $(BASE_CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
 
 $(BUILD_FP_OBJS): build/%.o: src/%.c
 	$(QUIET)echo "  CC FP $@"

=== debian/changelog ===
m1n1 (1.4.17-1) unstable; urgency=medium

  [ Sasha Finkelstein ]
  * clk: Revert PDM clock initialization.

 -- Tobias Heider <me@tobhe.de>  Thu, 28 Nov 2024 23:05:01 +0100

## m1n1 1.4.21

=== Makefile ===
--- 
+++ 
@@ -101,10 +101,14 @@
 	chickens.o \
 	chickens_avalanche.o \
 	chickens_blizzard.o \
+	chickens_cyclone_typhoon.o \
 	chickens_everest.o \
 	chickens_firestorm.o \
+	chickens_hurricane_zephyr.o \
+	chickens_monsoon_mistral.o \
 	chickens_icestorm.o \
 	chickens_sawtooth.o \
+	chickens_twister.o \
 	clk.o \
 	cpufreq.o \
 	dapf.o \
@@ -123,8 +127,9 @@
 	iodev.o \
 	iova.o \
 	isp.o \
-	kboot.o \
+	kboot.o kboot_atc.o \
 	main.o \
+	mitigations.o \
 	mcc.o \
 	memory.o memory_asm.o \
 	nvme.o \
@@ -169,10 +174,10 @@
 
 DEPDIR := build/.deps
 
-.PHONY: all clean format update_tag update_cfg invoke_cc
-all: update_tag update_cfg build/$(TARGET) build/$(TARGET_RAW)
+.PHONY: all clean format invoke_cc always_rebuild
+all: build/$(TARGET) build/$(TARGET_RAW)
 clean:
-	rm -rf build/*
+	rm -rf build/* build/.deps
 format:
 	$(CLANG_FORMAT) -i src/*.c src/dcp/*.c src/math/*.c src/*.h src/dcp/*.h src/math/*.h sysinc/*.h
 format-check:
@@ -201,7 +206,7 @@
 	$(QUIET)mkdir -p "$(dir $@)"
 	$(QUIET)$(CC) -c $(BASE_CFLAGS) -MMD -MF $(DEPDIR)/$(*F).d -MQ "$@" -MP -o $@ $<
 
-build/%.o: src/%.c
+build/%.o: src/%.c build-tag build-cfg
 	$(QUIET)echo "  CC    $@"
 	$(QUIET)mkdir -p $(DEPDIR)
 	$(QUIET)mkdir -p "$(dir $@)"
@@ -227,21 +232,19 @@
 	$(QUIET)echo "  RAW   $@"
 	$(QUIET)$(OBJCOPY) -O binary --strip-debug $< $@
 
-update_tag:
+.INTERMEDIATE: build-tag build-cfg
+build-tag src/../build/build_tag.h &:
 	$(QUIET)mkdir -p build
 	$(QUIET)./version.sh > build/build_tag.tmp
 	$(QUIET)cmp -s build/build_tag.h build/build_tag.tmp 2>/dev/null || \
 	( mv -f build/build_tag.tmp build/build_tag.h && echo "  TAG   build/build_tag.h" )
 
-update_cfg:
+build-cfg src/../build/build_cfg.h &:
 	$(QUIET)mkdir -p build
 	$(QUIET)for i in $(CFG); do echo "#define $$i"; done > build/build_cfg.tmp
 	$(QUIET)cmp -s build/build_cfg.h build/build_cfg.tmp 2>/dev/null || \
 	( mv -f build/build_cfg.tmp build/build_cfg.h && echo "  CFG   build/build_cfg.h" )
 
-build/build_tag.h: update_tag
-build/build_cfg.h: update_cfg
-
 build/%.bin: data/%.bin
 	$(QUIET)echo "  IMG   $@"
 	$(QUIET)mkdir -p "$(dir $@)"
@@ -257,8 +260,4 @@
 	$(QUIET)mkdir -p "$(dir $@)"
 	$(QUIET)cp $< $@
 
-build/main.o: build/build_tag.h build/build_cfg.h src/main.c
-build/usb_dwc3.o: build/build_tag.h src/usb_dwc3.c
-build/chainload.o: build/build_cfg.h src/usb_dwc3.c
-
 -include $(DEPDIR)/*

=== debian/changelog ===
m1n1 (1.4.21-3) unstable; urgency=medium

  * Team upload.
  * d/copyright: replace FSF physical address with web URL (fixes
    a lintian warning)

 -- NoisyCoil <noisycoil@tutanota.com>  Fri, 18 Apr 2025 13:42:10 +0200

m1n1 (1.4.21-2) unstable; urgency=medium

  * Team upload.

  [ NoisyCoil ]
  * Run wrap-and-sort -satb
  * d/control: declare compliance with Standards-Version 4.7.2
  * d/control: set Bananas Team as Maintainer and move tobhe to Uploaders
  * d/copyright: use issue tracker as Upstream-Contact
  * Add upstream metadata
  * d/patches: backport support for custom boot logos
  * Add Debian boot logo and infra for derivatives

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 15 Apr 2025 09:51:03 +0200

m1n1 (1.4.21-1) unstable; urgency=medium

  * New upstream version 1.4.21
  * Prevent NULL pointer dereference in dt_set_display() (Closes: #1094882)
  * Declare conflict with asahi-scripts (<< 20250130-1) because
    m1n1.conf moved from asahi-scripts to m1n1

 -- Tobias Heider <me@tobhe.de>  Sat, 01 Feb 2025 12:45:16 +0100

m1n1 (1.4.19-1) unstable; urgency=medium

  * New upstream version 1.4.19

 -- Tobias Heider <me@tobhe.de>  Tue, 28 Jan 2025 14:40:11 +0100

=== debian/control ===
Source: m1n1
Section: misc
Priority: optional
Maintainer: Debian Bananas Team <team+bananas@tracker.debian.org>
Uploaders:
 Tobias Heider <me@tobhe.de>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 imagemagick,
Standards-Version: 4.7.2
Homepage: https://github.com/AsahiLinux/m1n1
Vcs-Browser: https://salsa.debian.org/bananas-team/m1n1
Vcs-Git: https://salsa.debian.org/bananas-team/m1n1.git
Rules-Requires-Root: no

Package: m1n1
Architecture: arm64
Multi-Arch: foreign
Breaks:
 asahi-scripts (<< 20250130-1),
Replaces:
 asahi-scripts (<< 20250130-1),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Bootloader for Apple Silicon
 This is the bootloader developed by the Asahi Linux project to bridge
 the Apple (XNU) boot ecosystem to the Linux boot ecosystem.

## m1n1 1.5.0

=== Makefile ===
--- 
+++ 
@@ -3,10 +3,12 @@
 ifeq ($(shell uname),Darwin)
 USE_CLANG ?= 1
 $(info INFO: Building on Darwin)
-ifeq ($(shell uname -p),arm)
-TOOLCHAIN ?= /opt/homebrew/opt/llvm/bin/
-else
-TOOLCHAIN ?= /usr/local/opt/llvm/bin/
+BREW ?= $(shell command -v brew)
+TOOLCHAIN ?= $(shell $(BREW) --prefix llvm)/bin/
+ifeq ($(shell ls $(TOOLCHAIN)/ld.lld 2>/dev/null),)
+LLDDIR ?= $(shell $(BREW) --prefix lld)/bin/
+else
+LLDDIR ?= $(TOOLCHAIN)
 endif
 $(info INFO: Toolchain path: $(TOOLCHAIN))
 endif
@@ -15,12 +17,16 @@
 ARCH ?=
 else
 ARCH ?= aarch64-linux-gnu-
+endif
+
+ifneq ($(TOOLCHAIN),$(LLDDIR))
+$(info INFO: LLD path: $(LLDDIR))
 endif
 
 ifeq ($(USE_CLANG),1)
 CC := $(TOOLCHAIN)clang --target=$(ARCH)
 AS := $(TOOLCHAIN)clang --target=$(ARCH)
-LD := $(TOOLCHAIN)ld.lld
+LD := $(LLDDIR)ld.lld
 OBJCOPY := $(TOOLCHAIN)llvm-objcopy
 CLANG_FORMAT ?= $(TOOLCHAIN)clang-format
 EXTRA_CFLAGS ?=
@@ -95,7 +101,7 @@
 	afk.o \
 	aic.o \
 	asc.o \
-	bootlogo_128.o bootlogo_256.o \
+	bootlogo_48.o bootlogo_128.o bootlogo_256.o \
 	chainload.o \
 	chainload_asm.o \
 	chickens.o \
@@ -228,9 +234,20 @@
 	$(QUIET)echo "  MACHO $@"
 	$(QUIET)$(OBJCOPY) -O binary --strip-debug $< $@
 
+ifeq ($(LOGO),)
 build/$(NAME).bin: build/$(NAME)-raw.elf
 	$(QUIET)echo "  RAW   $@"
 	$(QUIET)$(OBJCOPY) -O binary --strip-debug $< $@
+
+else
+build/$(NAME)-asahi.bin: build/$(NAME)-raw.elf
+	$(QUIET)echo "  RAW   $@"
+	$(QUIET)$(OBJCOPY) -O binary --strip-debug $< $@
+
+build/$(NAME).bin: build/$(NAME)-asahi.bin build/$(LOGO).logo
+	$(QUIET)echo "  RAW   $@"
+	$(QUIET)cat $^ > $@
+endif
 
 .INTERMEDIATE: build-tag build-cfg
 build-tag src/../build/build_tag.h &:
@@ -260,4 +277,16 @@
 	$(QUIET)mkdir -p "$(dir $@)"
 	$(QUIET)cp $< $@
 
+build/%.rgba: data/%.png
+	$(eval SIZE := $(lastword $(subst _, ,$*)))
+	$(QUIET)echo "  MAGIC $@"
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)magick $< -background black -flatten -depth 8 -crop $(SIZE)x$(SIZE) -resize $(SIZE)x$(SIZE) rgba:$@
+
+build/%.logo: build/%_256.rgba build/%_128.rgba
+	$(QUIET)echo "  PAYLOAD $@"
+	$(QUIET)mkdir -p "$(dir $@)"
+	$(QUIET)echo -n "m1n1_logo_256128" > $@
+	$(QUIET)cat $^ >> $@
+
 -include $(DEPDIR)/*

=== debian/changelog ===
m1n1 (1.5.0-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- NoisyCoil <noisycoil@tutanota.com>  Mon, 18 Aug 2025 22:49:15 +0200

m1n1 (1.5.0-3) experimental; urgency=medium

  * Team upload.
  * d/control: version the B-D on imagemagick to avoid installing
    graphicsmagick, as the latter does not actually Provide the former
  * d/patches: drop use-convert-as-magic.patch, not needed anymore

 -- NoisyCoil <noisycoil@tutanota.com>  Sun, 17 Aug 2025 01:42:58 +0200

m1n1 (1.5.0-2) experimental; urgency=medium

  * Team upload.
  * d/patches: add use-convert-as-magic.patch to use convert as the
    MAGIC command

 -- NoisyCoil <noisycoil@tutanota.com>  Sun, 03 Aug 2025 13:12:42 +0200

m1n1 (1.5.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * d/patches: remove backported 0001-fb-Save-original-logo.patch and
    debian/patches/0002-fb-Add-custom-boot-logo-support.patch, now
    included upstream

 -- NoisyCoil <noisycoil@tutanota.com>  Sun, 03 Aug 2025 11:43:41 +0200

## m1n1 1.5.1

=== debian/changelog ===
m1n1 (1.5.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- NoisyCoil <noisycoil@debian.org>  Sun, 19 Oct 2025 00:06:59 +0200

## m1n1 1.5.2

=== Makefile ===
--- 
+++ 
@@ -134,6 +134,7 @@
 	iova.o \
 	isp.o \
 	kboot.o kboot_atc.o \
+	kboot_t6020_compat.o \
 	main.o \
 	mitigations.o \
 	mcc.o \

=== requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.13
# by the following command:
#
#    pip-compile requirements.ini
#
construct==2.10.70
    # via -r requirements.ini
pyserial==3.5
    # via -r requirements.ini

=== debian/changelog ===
m1n1 (1.5.2-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- NoisyCoil <noisycoil@debian.org>  Mon, 03 Nov 2025 17:28:36 +0100

m1n1 (1.5.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- NoisyCoil <noisycoil@debian.org>  Sun, 19 Oct 2025 16:05:34 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-exec,
- imagemagick,
+ imagemagick (>= 8:6.9.11.60~),
 Standards-Version: 4.7.2
 Homepage: https://github.com/AsahiLinux/m1n1
 Vcs-Browser: https://salsa.debian.org/bananas-team/m1n1

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

DEB_VENDOR_LC = $(shell echo $(DEB_VENDOR) | tr '[:upper:]' '[:lower:]')
LOGO_RADIX = $(CURDIR)/debian/logos/$(DEB_VENDOR_LC)
LOGO_DATA_RADIX = $(CURDIR)/data/$(DEB_VENDOR_LC)

ifneq (,$(wildcard $(LOGO_RADIX)_*))
LOGO_FLAG = LOGO=$(DEB_VENDOR_LC)
endif

override_dh_auto_build:
ifneq (,$(LOGO_FLAG))
	cp -a $(LOGO_RADIX)_128.png $(LOGO_RADIX)_256.png $(CURDIR)/data
endif
	dh_auto_build -- RELEASE=1 $(LOGO_FLAG)

override_dh_auto_clean:
	rm -f $(LOGO_DATA_RADIX)_128.png $(LOGO_DATA_RADIX)_256.png
	dh_auto_clean
	rm -df build

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/m1n1-$1\.tar\.gz/ \
  https://github.com/AsahiLinux/m1n1/tags .*\/v?(\d\S*)\.tar\.gz
